void do_menu() {

  /*
     Transpose,Velocity,NoteOffMode,InChannel,OutChannel[t],tracktype[t],ccnumber[t],velocitysource[t],transposesource[t],ClockDivider[t],PlayOnStart[t],NoteThru,ControlThru,ProgrammThru,BendThru,OtherChannelThru,CcEditMode,TrimmPotis,factoryreset,LoadSequence,SaveSequence,ClockSelect,TransposeCenter
     0        1         2           3         4             5            6           7                8                 9               10             11       12          13          ,14      ,15              ,16        ,17        ,18          ,19          ,20          ,21         ,22
  */




  switch (menu) {
    // getDataValue(int myvalue, int maxValue, int minValue, int incten, int runover)
    case 0 : //GLOBAL TRANSPOSE
      if (edit == 1) transposemode = getDataValue(transposemode, 3 + maxTracks, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("TRANSPOSE    All"));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (transposemode == 0) lcd.print(F("Off           "));
        if (transposemode == 1) lcd.print(F("Continous     "));
        if (transposemode == 2) lcd.print(F("Momentary     "));
        if (transposemode == 3) lcd.print(F("ButtonEnabled "));
        if (transposemode >= 4) {
          lcd.print(F("Track "));
          lcd.print(transposemode - 3);
          lcd.print(F("         "));
        }
      }
      saveMemory = 8;
      saveValue = transposemode;
      break;

    case 1 : //GLOBAL VELOCITY
      if (edit == 1) velocitymode = getDataValue(velocitymode, 1 + maxTracks, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("VELOCITY     All"));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (velocitymode == 0) lcd.print(F("Constant (CV1)  "));
        if (velocitymode == 1) lcd.print(F("Random   (CV2)  "));
        if (velocitymode >= 2) {
          lcd.print(F("Track "));
          lcd.print(velocitymode - 1);
          lcd.print(F("         "));
        }
      }
      saveMemory = 8;
      saveValue = transposemode;
      break;

    case 2: //NOTEOFFMODE
      if (edit == 1) noteoffmode = getDataValue(noteoffmode, 2, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("NOTEOFF-MODE All"));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (noteoffmode == 0) lcd.print(F("Legato       "));
        if (noteoffmode == 1) lcd.print(F("Gated        "));
        if (noteoffmode == 2) lcd.print(F("CV-ctrl      "));
      }
      saveMemory = 9;
      saveValue = noteoffmode;
      break;


    case 3://INCHANNEL
      if (edit == 1) inchannel = getDataValue(inchannel, 16, 1, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("IN CHANNEL   All"));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        lcd.print(inchannel);
        lcd.print(F("      "));
      }
      saveMemory = 5;
      saveValue = inchannel;
      MIDI.setInputChannel(inchannel);
      break;




    case 4://OUTCHANNEL T
      if (edit == 1) outchannel[selectedtrack] = getDataValue(outchannel[selectedtrack], 16, 1, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("OUT CHANNEL "));
      lcd.print(F("Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        lcd.print(outchannel[selectedtrack]);
        lcd.print(F("  "));
      }
      saveMemory = 32 + (3 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = outchannel[i];
      }
      break;

    case 5: //TRACKTYPE T
      if (edit == 1) tracktype[selectedtrack] = getDataValue(tracktype[selectedtrack], 3, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("TRACKTYPE   "));
      lcd.print(F("Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (tracktype[selectedtrack] == 0) lcd.print(F("Note           "));
        if (tracktype[selectedtrack] == 1) lcd.print(F("CC             "));
        if (tracktype[selectedtrack] == 2) lcd.print(F("Velocity       "));
        if (tracktype[selectedtrack] == 3) lcd.print(F("Transpose      "));
      }
      saveMemory = 32 + (0 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = tracktype[i];
      }
      break;

    case 6://CC-NUMBER T
      if (edit == 1) ccnumber[selectedtrack] = getDataValue(ccnumber[selectedtrack], 127, 1, 0, 1);
      if (edit == 1 && button4State == 1 && button5State == 1) ccnumber[selectedtrack] =  (invalue[1]);
      lcd.setCursor(0, 0);
      lcd.print(F("CC-NUMBER   "));
      lcd.print(F("Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));

      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (tracktype[selectedtrack] != 1) {
          lcd.print(F("Not a CC-Track"));
        } else {
          lcd.print(ccnumber[selectedtrack]);
          lcd.print(F(" "));
                lcd.print(EEPROM.length());
                lcd.print(F("             "));
        }
      }
      saveMemory = 32 + (1 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = ccnumber[i];
      }
      break;

    case 7://velocitysource T
      if (edit == 1) velocitysource[selectedtrack] = getDataValue(velocitysource[selectedtrack], maxTracks + 2, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("VEL.SOURCE  Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (tracktype[selectedtrack] != 0) {
          lcd.print(F("Not a note-trk "));
        } else {
          if (velocitysource[selectedtrack] == maxTracks)     lcd.print(F("Constant (CV1)  "));
          if (velocitysource[selectedtrack] == maxTracks + 1) lcd.print(F("Random   (CV2)  "));
          if (velocitysource[selectedtrack] == maxTracks + 2) lcd.print(F("Global Velocity "));
          if (velocitysource[selectedtrack] < maxTracks) {
            lcd.print(F("Track "));
            lcd.print(velocitysource[selectedtrack] + 1);
            if (tracktype[velocitysource[selectedtrack]] != 2) {
              lcd.print(F(" (?)          "));
            } else {
              lcd.print(F("              "));
            }
          }
        }
      }
      saveMemory = 32 + (4 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = velocitysource[i];
      }
      break;

    case 8://transposesource T
      if (edit == 1) transposesource[selectedtrack] = getDataValue(transposesource[selectedtrack], maxTracks + 1, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("TRANS.SRC   Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (tracktype[selectedtrack] != 0) lcd.print(F("Not a note-trk "));
        if (transposesource[selectedtrack] == maxTracks)     lcd.print(F("No Transpose    "));
        if (transposesource[selectedtrack] == maxTracks + 1) lcd.print(F("Global Transp.  "));
        if (transposesource[selectedtrack] == selectedtrack) lcd.print(F("Invalid         "));
        if (transposesource[selectedtrack] < maxTracks) {
          lcd.print(F("Track "));
          lcd.print(transposesource[selectedtrack] + 1);
          if (tracktype[transposesource[selectedtrack]] != 3) {
            lcd.print(F(" (?)          "));
          } else {
            lcd.print(F("              "));
          }
        }
      }

      saveMemory = 32 + (5 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = transposesource[i];
      }
      break;

    case 9://CLOCKDIVIDER T
      if (edit == 1) {
        if (button2State == 1) {
          clockdivider[selectedtrack] = (invalue[1] + 1);
        }
        clockdivider[selectedtrack] = getDataValue(clockdivider[selectedtrack], 128, 1, 0, 1);
      }
      lcd.setCursor(0, 0);
      lcd.print(F("CLOCKDIVIS. "));
      lcd.print(F("Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        lcd.print(clockdivider[selectedtrack]);
        lcd.print(F("  "));
      }

      saveMemory = 32 + (2 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = clockdivider[i];
      }
      break;

    case 10: //START BEHAVIOUR T
      if (edit == 1) playonstart[selectedtrack] = getDataValue(playonstart[selectedtrack], 1, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("PLAYONSTART Tr"));
      lcd.print(selectedtrack + 1);
      lcd.print(F(" "));
      if ( displaymode == 0) {
        lcd.setCursor(1, 1);
        if (playonstart[selectedtrack] == 0) lcd.print(F("Immediate start"));
        if (playonstart[selectedtrack] == 1) lcd.print(F("Obey pause mode"));
      }
      saveMemory = 32 + (6 * maxTracks);
      saveMulti = 1;
      for ( i = 0; i < maxTracks; i++ ) {
        saveValueMulti[i] = playonstart[i];
      }
      break;



    case 11: //NOTETHRU
      notethrumode = getDataValue(notethrumode, 4, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("NOTE-THRU-MODE"));
      if (displaymode == 0) {
        lcd.setCursor(1, 1);
        if (notethrumode == 0) lcd.print(F("Off          "));
        if (notethrumode == 1) lcd.print(F("Record       "));
        if (notethrumode == 2) lcd.print(F("Play         "));
        if (notethrumode == 3) lcd.print(F("Rec+Play     "));
        if (notethrumode == 4) lcd.print(F("PlayTriggered"));
      }
      saveMemory = 11;
      saveValue = notethrumode;
      break;

    case 12: //CONTROLTHRU
      controlthrumode = getDataValue(controlthrumode, 1, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("CTRL-THRU-MODE"));
      if (displaymode == 0) {
        lcd.setCursor(1, 1);
        if (controlthrumode == 0) lcd.print(F("Off"));
        if (controlthrumode == 1) lcd.print(F("On "));
      }
      saveMemory = 12;
      saveValue = controlthrumode;
      break;

    case 13: //PROGRAM
      programthrumode = getDataValue(programthrumode, 1, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("PRG-THRU-MODE"));
      if (displaymode == 0) {
        lcd.setCursor(1, 1);
        if (programthrumode == 0) lcd.print(F("Off"));
        if (programthrumode == 1) lcd.print(F("On "));
      }
      saveMemory = 13;
      saveValue = programthrumode;
      break;

    case 14: //BENDER
      bendthrumode = getDataValue(bendthrumode, 1, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("BEND-THRU-MODE"));
      if (displaymode == 0) {
        lcd.setCursor(1, 1);
        if (bendthrumode == 0) lcd.print(F("Off"));
        if (bendthrumode == 1) lcd.print(F("On "));
      }
      saveMemory = 14;
      saveValue = bendthrumode;
      break;

    case 15: //OTHER-CHANNELS-THRU
      otherthrumode = getDataValue(otherthrumode, 1, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("OTHER-THRU-MODE"));
      if (displaymode == 0) {
        lcd.setCursor(1, 1);
        if (otherthrumode == 0) lcd.print(F("Off"));
        if (otherthrumode == 1) lcd.print(F("On "));
      }
      saveMemory = 15;
      saveValue = otherthrumode;
      if (otherthrumode == 0) {
        MIDI.setThruFilterMode(0);
        MIDI.turnThruOff();
      }
      if (otherthrumode == 1) {
        MIDI.setThruFilterMode(3);
        MIDI.turnThruOn(3);
      }
      break;

    case 16: //OSMOSEMODE NOT YET IN USE
      if (edit == 0) {
        lcd.setCursor(0, 0);
        lcd.print(F("COPY TRACK  "));
        lcd.print(F("Tr"));
        lcd.print(selectedtrack + 1);
        lcd.print(F(" "));

        lcd.setCursor(1, 1);
        lcd.print(F("PRESS WRITE   "));
        if (button3State == 1 && button3StatePrev == 0) {
          button3StatePrev = 1;
          EEPROM.write((440 + 0), tracktype[selectedtrack]);
          EEPROM.write((440 + 1), ccnumber[selectedtrack]);
          EEPROM.write((440 + 2), clockdivider[selectedtrack]);
          EEPROM.write((440 + 3), outchannel[selectedtrack]);
          EEPROM.write((440 + 4), velocitysource[selectedtrack]);
          EEPROM.write((440 + 5), transposesource[selectedtrack]);
          EEPROM.write((440 + 6), playonstart[selectedtrack]);
          button2StatePrev = 0;
          edit = 1;
        }
        if (button3State == 0 && button3StatePrev == 1) {
          button3StatePrev = 0;
        }
      }
      if (edit == 1) {
        lcd.setCursor(0, 0);
        lcd.print(F("TO TRACK    "));
        lcd.print(F("Tr"));
        lcd.print(selectedtrack + 1);
        lcd.print(F(" "));
        lcd.setCursor(1, 1);
        lcd.print(F("WRITE or STOP "));
        if (button3State == 1 && button3StatePrev == 0) {
          button3StatePrev = 1;
          tracktype[selectedtrack]       = EEPROM.read((440 + 0));
          ccnumber[selectedtrack]        = EEPROM.read((440 + 1));
          clockdivider[selectedtrack]    = EEPROM.read((440 + 2));
          outchannel[selectedtrack]      = EEPROM.read((440 + 3));
          velocitysource[selectedtrack]  = EEPROM.read((440 + 4));
          transposesource[selectedtrack] = EEPROM.read((440 + 5));
          playonstart[selectedtrack]     = EEPROM.read((440 + 6));
        }
        if (button3State == 0 && button3StatePrev == 1) {
          button3StatePrev = 0;
        }
        if (button2State == 1 && button2StatePrev == 0) {
          button2StatePrev = 1;
          edit = 0;
        }
        if (button2State == 0 && button2StatePrev == 1) {
          button2StatePrev = 0;
        }
      }


      break;


    case 17: //POTENTIOMETER ADJUSTMENT
      if (edit == 0) {
        lcd.setCursor(0, 0);
        lcd.print(F("ADJUST POTI-CVs"));
        lcd.setCursor(1, 1);
        lcd.print(F("PRESS WRITE"));
      }
      if (edit == 1) {
        lcd.setCursor(0, 0);
        lcd.print(F("SET POTIS TO MAX"));
        lcd.setCursor(1, 1);
        lcd.print(F("THEN PRESS WRITE"));
        if (button3State == 1 && button3StatePrev == 0) {
          button3StatePrev = 1;
          clearscreen();
          adjuststep = 0;
          adjustpotis();
          edit = 0;
          clearscreen();
        }
        if (button3State == 0 && button3StatePrev == 1) button3StatePrev = 0;
      }
      break;

    case 18: //FACTORY RESET
      if (edit == 0) {
        lcd.setCursor(0, 0);
        lcd.print(F("FACTORY RESET"));
        lcd.setCursor(1, 1);
        lcd.print(F("PRESS 2xWRITE"));
      }
      if (edit == 1) {
        lcd.setCursor(0, 0);
        lcd.print(F("RESET:PRESS WRITE"));
        lcd.setCursor(1, 1);
        lcd.print(F("STOP TO CANCEL"));
        if (button3State == 1 && button3StatePrev == 0) {
          runmode = 0;
          button3StatePrev = 1;
          eepromfactoryreset();
          clearscreen();
          loadsettings();
          loadfactorysequence();
          savesequence();
          //delay(10);
          edit = 0;
          clearscreen();
          menu = 0;
        }
        if (button3State == 0 && button3StatePrev == 1) button3StatePrev = 0;
        if (button2State == 1 && button2StatePrev == 0 && menu > 0) {
          button2StatePrev = 1;
        }
        if (button2State == 0 && button2StatePrev == 1 && menu > 0) {
          button2StatePrev = 0;
          clearscreen();
          edit = 0;
        }
      }
      break;

    case 19: //LOAD SEQUENCE
      if (edit == 0) {
        lcd.setCursor(0, 0);
        lcd.print(F("LOAD PATTERN"));
        lcd.setCursor(1, 1);
        lcd.print(F("PRESS 2xWRITE"));
      }
      if (edit == 1) {
        lcd.setCursor(0, 0);
        lcd.print(F("LOAD PRESS WRITE"));
        lcd.setCursor(1, 1);
        lcd.print(F("STOP FOR CANCEL"));
        if (button3State == 1 && button3StatePrev == 0) {
          runmode = 0;
          button3StatePrev = 1;
          loadsequence();
          //delay(10);
          edit = 0;
          clearscreen();
        }
        if (button3State == 0 && button3StatePrev == 1) {
          button3StatePrev = 0;
        }
        if (button2State == 1 && button2StatePrev == 0 && menu > 0) {
          button2StatePrev = 1;
        }
        if (button2State == 0 && button2StatePrev == 1 && menu > 0) {
          button2StatePrev = 0;
          clearscreen();
          edit = 0;
        }
      }
      break;

    case 20: //SAVE SEQUENCE
      if (edit == 0) {
        lcd.setCursor(0, 0);
        lcd.print(F("SAVE PATTERN"));
        lcd.setCursor(1, 1);
        lcd.print(F("PRESS 2xWRITE"));
      }
      if (edit == 1) {
        lcd.setCursor(0, 0);
        lcd.print(F("SAVE PRESS WRITE"));
        lcd.setCursor(1, 1);
        lcd.print(F("STOP FOR CANCEL"));
        if (button3State == 1 && button3StatePrev == 0) {
          button3StatePrev = 1;
          savesequence();
          edit = 0;
          lcd.setCursor(1, 1);
          lcd.print(F("SAVE DONE    "));
          if (runmode == 0) delay(500);
          clearscreen();
        }
        if (button3State == 0 && button3StatePrev == 1) {
          button3StatePrev = 0;
        }
        if (button2State == 1 && button2StatePrev == 0 && menu > 0) {
          button2StatePrev = 1;
        }
        if (button2State == 0 && button2StatePrev == 1 && menu > 0) {
          button2StatePrev = 0;
          clearscreen();
          edit = 0;
        }
      }
      break;

    case 21: //CLOCK SELECT
      clockmode = getDataValue(clockmode, 2, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("CLOCK SOURCE"));
      lcd.setCursor(1, 1);
      if (clockmode == 0) lcd.print(F("Internal       "));
      if (clockmode == 1) lcd.print(F("MIDI Clock     "));
      if (clockmode == 2) lcd.print(F("VMC Clock      "));
      saveMemory = 6;
      saveValue = clockmode;

      saveMulti = 0;
      break;

    case 22: //START/STOP CONTROL
      startstopmode = getDataValue(startstopmode, 2, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("START/STOP SRC"));
      lcd.setCursor(1, 1);
      if (startstopmode == 0) lcd.print(F("Internal only  "));
      if (startstopmode == 1) lcd.print(F("MIDI START/STOP"));
      if (startstopmode == 2) lcd.print(F("VMC START/STOP "));
      saveMemory = 18;
      saveValue = startstopmode;
      saveMulti = 0;
      break;

    case 23: //SEND CLOCK
      sendclock = getDataValue(sendclock, 3, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("SEND CLOCK TO..."));
      lcd.setCursor(1, 1);
      if (sendclock == 0) lcd.print(F("...none        "));
      if (sendclock == 1) lcd.print(F("...MIDI        "));
      if (sendclock == 2) lcd.print(F("...MIDI + VMC  "));
      if (sendclock == 3) lcd.print(F("...VMC         "));
      saveMemory = 19;
      saveValue = sendclock;
      saveMulti = 0;
      break;

    case 24: //CLOCK DIVIDER
      inclockdivider = getDataValue(inclockdivider, 6, 0, 0, 1);
      lcd.setCursor(0, 0);
      lcd.print(F("CLOCK DIVIDER"));
      lcd.setCursor(1, 1);


      if (inclockdivider == 0) {
        lcd.print(F("1/16          "));
      }
      if (inclockdivider == 1) {
        lcd.print(F("1/8           "));
      }
      if (inclockdivider == 2) {
        lcd.print(F("1/4           "));
      }
      if (inclockdivider == 3) {
        lcd.print(F("1/1           "));
      }
      if (inclockdivider == 4) {
        lcd.print(F("2/1           "));
      }
      if (inclockdivider == 5) {
        lcd.print(F("1/12          "));
      }
      if (inclockdivider == 6) {
        lcd.print(F("1/24          "));
      }
      setClockFactor();
      saveMemory = 17;
      saveValue = inclockdivider;
      saveMulti = 0;
      break;


    case 25: //TRANSPOSE CENTER NOTE
      lcd.setCursor(0, 0);
      lcd.print(F("TRANSP.CENTER"));
      lcd.setCursor(1, 1);
      lcd.print(transposecenter);
      lcd.print(F(" or send note  "));

      if (edit == 1) {
        if (button2State == 1) {
          transposecenter = (invalue[1]);
        }
        if (button4State == 0 && button5State == 0) {
          if (MIDI.read()) {
            byte type = MIDI.getType() ;
            if (type == midi::NoteOn && MIDI.getChannel() == inchannel) {
              transposecenter = MIDI.getData1();
            }
          }
        }
        transposecenter = getDataValue(transposecenter, 127, 1, 0, 1);
      }
      saveMemory = 7;
      saveValue = transposecenter;
      break;
  } // END OF SWITCH:CASE

} // END OF DO_MENU()
